//=============================================================================
// ProMesh.NET - .NET Web Application Framework 
//
// Copyright (c) 2003-2008 Philippe Leybaert
//
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in 
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.
//=============================================================================

using System;
using System.Collections.Generic;
using System.Collections.Specialized;

namespace Activa.ProMesh
{
    internal class ControllerAction
    {
        private ControllerClass _controllerClass;
        private string _actionMethod;
        private NameValueCollection _parameters = new NameValueCollection();

        public ControllerAction()
        {
        }

        public ControllerAction(ControllerClass controllerClass)
        {
            _controllerClass = controllerClass;
            _actionMethod = "Run";
        }

        public ControllerAction(ControllerClass controllerClass, string actionMethod)
        {
            _controllerClass = controllerClass;
            _actionMethod = actionMethod;
        }

        public ControllerClass ControllerClass
        {
            get { return _controllerClass; }
            set { _controllerClass = value; }
        }

        public string ActionMethod
        {
            get { return _actionMethod; }
            set { _actionMethod = value; }
        }

        public NameValueCollection Parameters
        {
            get { return _parameters; }
            set { _parameters = value; }
        }
    }
}
