//=============================================================================
// ProMesh.NET - .NET Web Application Framework 
//
// Copyright (c) 2003-2008 Philippe Leybaert
//
// Permission is hereby granted, free of charge, to any person obtaining a copy 
// of this software and associated documentation files (the "Software"), to deal 
// in the Software without restriction, including without limitation the rights 
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
// copies of the Software, and to permit persons to whom the Software is 
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in 
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
// IN THE SOFTWARE.
//=============================================================================
//
// Original MootoolsAjaxProvider class created by Edwin De Jonge
//

using System;
using System.Collections.Generic;
using System.Text;

namespace Activa.ProMesh
{
    public class MootoolsAjaxProvider : IAjaxProvider
    {
        public string SetupFramework()
        {
            return "";
        }

        public string GenerateJavascriptClassName(string className)
        {
            StringBuilder output = new StringBuilder();

            string[] parts = className.Split('.');

            string runningPart = "";

            foreach (string part in parts)
            {
                runningPart += part;

                output.Append("if (typeof " + runningPart + " == \"undefined\") " + runningPart + " = {};\r\n");

                runningPart += '.';
            }

            return output.ToString();
        }

        public string GenerateJavascriptMethod(string url, string className, string methodName, string[] parameters, bool includePostData, Dictionary<string, string> contextData)
        {
            StringBuilder output = new StringBuilder();

            output.Append(className + '.');
            output.Append(methodName);
            output.Append(" = function(");
            output.Append(String.Join(", ", parameters));

            if (parameters.Length > 0)
                output.Append(", ");

            output.Append("__callback, __errorcallback");

            output.Append("){\r\n");
            output.Append("  var data = { ");

            for (int i = 0; i < parameters.Length; i++)
            {
                if (i > 0)
                    output.Append(',');

                output.Append("\"" + parameters[i] + "\" : " + parameters[i]);
            }
            output.Append("};\r\n");
            output.Append("  new Ajax( \"" + url + "\", {\r\n");
            output.Append("         onSuccess: function (txt, xml) { txt = eval('('+txt+')'); if (__callback) __callback(txt.value);},\r\n");
            output.Append("         onException: function(e, type, msg) { if (__errorcallback) __errorcallback(msg); }\r\n");
            output.Append("       }).request(data);\r\n");
            output.Append("};\r\n");

            return output.ToString();
        }
    }
}
