using System;
using Activa.CoolStorage;

namespace Activa.ProMesh
{
	[MapTo("awtPageLog")]
	public abstract class PageLogEntry : CSObject<PageLogEntry,int>
	{
		public abstract int PageLogID { get; }
		public abstract string PageID { get; set; }
        public abstract string QueryString { get; set; }
		public abstract DateTime CreationTime { get; set; }
		public abstract int SessionID { get; set; }
		public abstract int LanguageID { get; set; }
		public abstract int? ElapsedRun { get; set; }
        public abstract int? ElapsedRender { get; set; }
        public abstract int? Elapsed { get; set; }

		[ManyToOne] public abstract Session Session { get; set; }
		[OneToMany] public abstract CSList<TrafficEntry> TrafficEntries { get; }
	}

}