using System;
using Activa.LazyParser;

namespace Activa.SharpTemplate
{
	public class EvaluatedTokenEventArgs<T> : EvaluatedEventArgs<T>
	{
		private readonly TokenMatch _tokenMatch;
		private readonly IParserContext _context;

		public EvaluatedTokenEventArgs(IParserContext context, TokenMatch tokenMatch, T result) : base(result)
		{
			_context = context;
			_tokenMatch = tokenMatch;
		}

		public TokenMatch TokenMatch
		{
			get { return _tokenMatch; }
		}

		public IParserContext Context
		{
			get { return _context; }
		}
	}
}